body {
  overflow: hidden;
}

input {
  max-width: 80px;
}

#container {
  display: grid;
  grid-template-columns: 1fr minmax(25%, 150px);
  height: 100vh;
  overflow: hidden;
}

#main-area {
  position: relative;
}

.draw-canvas {
  position: absolute;
  top: 0;
  left: 0;
  right: 0;
  z-index: 10;
}

#test-canvas-controls,
#timeline {
  position: absolute;
  left: 0;
  bottom: 0;
  width: 100%;
  z-index: 12;
  user-select: none;
}
#test-canvas-controls {
  height: 80px;
}
#timeline {
  height: 160px;
}

#video-placeholder-file-input-button {
  z-index: 50;
}

#video-player {
  position: absolute;
  top: 0;
  left: 0;
  right: 0;
  bottom: 160px;
}

#timeline-buttons {
  height: 20px;
}

#layer-remove-handles {
  width: 8px;
  padding: 2px 0;
  display: flex;
  flex-direction: column-reverse;
}
#layer-remove-handles > *:not(:last-child) {
  margin-top: 2px;
}

#layer-pickers {
  width: 8px;
  padding: 2px 0;
  display: flex;
  flex-direction: column-reverse;
}
#layer-pickers > *:not(:last-child) {
  margin-top: 2px;
}

#timeline-zoom-indicator,
#timeline-current-frame,
#timeline-reference-frames-wrapper {
  position: absolute;
  top: 0;
  bottom: 0;
  left: 0;
}

#timeline-current-layer {
  position: absolute;
  left: 0;
  right: 0;
  background-color: rgba(160, 212, 255, 0.45);
  height: 8px;
}

/* Timeline zoom */
#timeline-zoom-wrapper {
  position: relative;
  width: 100%;
  height: 24px;
  background-color: #d1d5db;
  margin-bottom: 8px;
}

#timeline-zoom-indicator {
  width: 100%;
  margin: auto;
}

#timeline-zoom-wrapper input[type="range"] {
  -webkit-appearance: none;
  -moz-appearance: none;
  appearance: none;
  width: 100%;
  max-width: none;
  outline: none;
  position: absolute;
  margin: auto;
  top: 0;
  bottom: 0;
  background-color: transparent;
  pointer-events: none;
}
#timeline-zoom-wrapper input[type="range"]::-webkit-slider-runnable-track {
  -webkit-appearance: none;
  height: 5px;
}
#timeline-zoom-wrapper input[type="range"]::-moz-range-track {
  -moz-appearance: none;
  height: 5px;
}
#timeline-zoom-wrapper input[type="range"]::-ms-track {
  appearance: none;
  height: 5px;
}
#timeline-zoom-wrapper input[type="range"]::-webkit-slider-thumb {
  -webkit-appearance: none;
  height: 24px;
  width: 0.5rem;
  background-color: #93c5fd;
  cursor: col-resize;
  margin-top: -10px;
  pointer-events: auto;
}
#timeline-zoom-wrapper input[type="range"]:hover::-webkit-slider-thumb {
  background-color: #bfdbfe;
}
#timeline-zoom-wrapper input[type="range"]::-moz-range-thumb {
  -webkit-appearance: none;
  height: 24px;
  width: 0.5rem;
  background-color: #93c5fd;
  cursor: col-resize;
  pointer-events: auto;
}
#timeline-zoom-wrapper input[type="range"]:hover::-moz-range-thumb {
  background-color: #bfdbfe;
}
#timeline-zoom-wrapper input[type="range"]::-ms-thumb {
  appearance: none;
  height: 24px;
  width: 0.5rem;
  background-color: #93c5fd;
  cursor: col-resize;
  pointer-events: auto;
}
#timeline-zoom-wrapper input[type="range"]:hover::-ms-thumb {
  background-color: #bfdbfe;
}
#timeline-zoom-wrapper input[type="range"]:active::-webkit-slider-thumb {
  background-color: #ffffff;
  border: 3px solid #3264fe;
}

#timeline-zoom-indicator-dragger {
  cursor: move;
  height: 100%;
}

#timeline-zoom-indicator-dragger:hover {
  border: 1px solid white;
  background-color: rgba(0, 0, 0, 0.1);
}
/* Timeline wrapper */
#timeline-current-frame,
#timeline-zoom-indicator-current-frame {
  width: 2px;
  background-color: #b81a1a;
  z-index: 100;
  height: 100%;
  pointer-events: none;
}

#timeline-reference-frames-wrapper {
  right: 0;
}

#timeline-reference-frames-wrapper .frame,
#timeline-reference-frames-wrapper .frame-light {
  position: absolute;
  top: 0;
  bottom: 0;
  pointer-events: none;
}
#timeline-reference-frames-wrapper .frame {
  width: 2px;
  background-color: #ccc;
}
#timeline-reference-frames-wrapper .frame-light {
  width: 1px;
  background-color: #bbb;
}

#new-preset-name-panel {
  position: absolute;
  left: 0;
  bottom: -4px;
  transform: translateY(100%);
  z-index: 9999;
}

#new-preset-name-panel input {
  max-width: none !important;
}

/* TOOLBAR */
#version {
  font-size: 12px;
  opacity: 0.65;
  text-align: right;
  margin: 0;
}

#color-swatches-grid {
  display: grid;
  grid-template-columns: repeat(auto-fill, 28px);
  grid-gap: 4px;
}

.color-swatch {
  width: 28px;
  height: 28px;
  cursor: pointer;
  opacity: 1;
  border-radius: 4px;
}
.color-swatch:hover {
  opacity: 0.7;
}

/* ACTIONS */
.action-stroke,
.action-config {
  background-color: #d4ebfd;
  z-index: 100;
  height: 8px;
  cursor: pointer;
}

.action-stroke {
  border-radius: 9999px;
}

.action-config {
  width: 8px;
  transform: rotate(45deg);
}

.action-stroke:hover,
.action-config:hover {
  background-color: #c3d8e9;
}
.action-stroke.selected,
.action-config.selected  {
  background-color: #f7a75c;
}

/* LAYERS */
.layer-remove-handle {
  width: 8px;
  height: 8px;
}
.layer-remove-handle:not(.disabled) {
  cursor: pointer;
  color: #6cb0e7;
  display: grid;
  place-items: center;
}
.layer-remove-handle:hover {
  color: #c3d8e9;
}

.layer-picker {
  width: 8px;
  height: 8px;
  opacity: 1;
  cursor: pointer;
  border-radius: 50%;
}
.layer-picker:not(.new) {
  background-color: #6cb0e7;
}
.layer-picker.new {
  color: #6cb0e7;
  display: grid;
  place-items: center;
  font-size: 12px;
  line-height: 8px;
  font-weight: bold;
}
.layer-picker.new:hover {
  color: #c3d8e9;
}
.layer-picker:not(.selected):not(.new) {
  opacity: 0.5;
}

/* MISC */
.overlay {
  z-index: 30;
}

#toasts-holder {
  position: absolute;
  bottom: 16px;
  left: 16px;
  display: flex;
  flex-direction: column;
  row-gap: 8px;
}

.toast {
  animation-name: toast-fade;
  animation-duration: 3s;
}

@keyframes toast-fade {
  0% { opacity: 0; }
  20% { opacity: 1; }
  80% { opacity: 1; }
  100% { opacity: 0; }
}
